BuildMode = {}
function BuildMode_Cancel(Client_ID,Reason)
	BuildMode[Client_ID] = {
		mode=0,
		blocks={}
	}
	if Reason then
		System_Message_Network_Send(Client_ID, "&eBuild mode cancelled. ("..Reason..")")
	end
end
function BuildMode_Login(Client_ID)
	BuildMode_Cancel(Client_ID)
end
Client_Examine() 
while Client_Next() ~= 0 do 
	local Client_ID = Client_Get_ID() 
	BuildMode_Cancel(Client_ID)
end

local Build_Funcs = {
	{
		name="sphere",
		desc="Sphere(pythagoras theorem)",
		blocks=2,
		rank=100,
		--rankshow=100,
		create=function(Client_ID, ...) end, --can be used for info, etc..
		finish=function(Client_ID, ...)
			local Map_ID,Mat1,X1,Y1,Z1 = unpack(arg[1])
			local Map_ID2,Mat2,X2,Y2,Z2 = unpack(arg[2])
			if Map_ID ~= Map_ID2 then return end
			local R = math.floor(getDistance3D(X1,Y1,Z1,X2,Y2,Z2))
			if R > 32 then
				System_Message_Network_Send(Client_ID, "&eSphere too big..")
				return
			end
			local R2 = R^2
			--local CX, CY, CZ = (X1+X2)/2,(Y1+Y2)/2,(Z1+Z2)/2
			for ix=-R,R do
				for iy=-R,R do
					for iz=-R,R do
						if math.pow(ix,2)+math.pow(iy,2)+math.pow(iz,2) <= R2 then
							--print("debug...")
							Map_Block_Change(Client_ID, Map_ID, X1+ix, Y1+iy, Z1+iz, 1, Mat2, 0, 1, 0)
						end
					end
				end
			end
		end
	},
	{
		name="circle",
		blocks=2,
		rank=100,
		rankshow=100,
		desc="Filled Circle(pythagoras theorem)",
		create=function(Client_ID, ...) end, --can be used for info, etc..
		finish=function(Client_ID, ...)
			local Map_ID,Mat1,X1,Y1,Z1 = unpack(arg[1])
			local Map_ID2,Mat2,X2,Y2,Z2 = unpack(arg[2])
			if Map_ID ~= Map_ID2 then return end
			local R = math.floor(getDistance3D(X1,Y1,0,X2,Y2,0))
			if R > 256 then
				System_Message_Network_Send(Client_ID, "&eCircle too big..")
				return
			end
			local R2 = R*R
			--local CX, CY, CZ = (X1+X2)/2,(Y1+Y2)/2,(Z1+Z2)/2
			
			
			for ix=-R,R do
				for iy=-R,R do
					if math.pow(ix,2)+math.pow(iy,2) <= R2 then
						--print("debug...")
						Map_Block_Change(Client_ID, Map_ID, X1+ix, Y1+iy, Z1, 1, Mat2, 4, 1, 0)
						--Map_Block_Change_Fast(-1, Map_ID, X1+ix, Y1+iy, Z1, Mat2, 4, 0, 0, 1)
					end
				end
			end
		end
	},
	{
		name="hcircle",
		blocks=2,
		rank=100,
		rankshow=100,
		desc="Hollow Circle(pythagoras theorem)",
		create=function(Client_ID, ...) end, --can be used for info, etc..
		finish=function(Client_ID, ...)
			local Map_ID,Mat1,X1,Y1,Z1 = unpack(arg[1])
			local Map_ID2,Mat2,X2,Y2,Z2 = unpack(arg[2])
			if Map_ID ~= Map_ID2 then return end
			local R = math.floor(getDistance3D(X1,Y1,0,X2,Y2,0))
			if R > 256 then
				System_Message_Network_Send(Client_ID, "&eCircle too big..")
				return
			end
			local R2 = R^2
			local R3 = (R-1)^2
			
			for ix=-R,R do
				for iy=-R,R do
					local dis = math.pow(ix,2)+math.pow(iy,2)
					if dis <= R2 and dis >= R3 then
						Map_Block_Change(Client_ID, Map_ID, X1+ix, Y1+iy, Z1, 1, Mat2, 4, 1, 0)
					end
				end
			end
		end
	},
	{
		name="bhcircle",
		blocks=2,
		rank=100,
		rankshow=100,
		desc="Hollow Circle(midpoint circle algorithm)",
		create=function(Client_ID, ...) end, --can be used for info, etc..
		finish=function(Client_ID, ...)
			local Map_ID,Mat1,X1,Y1,Z1 = unpack(arg[1])
			local Map_ID2,Mat2,X2,Y2,Z2 = unpack(arg[2])
			if Map_ID ~= Map_ID2 then return end
			local R = math.floor(getDistance3D(X1,Y1,0,X2,Y2,0))
			if R > 256 then
				System_Message_Network_Send(Client_ID, "&eCircle too big..")
				return
			end
			local f = 1 - R
			local ddF_x = 1
			local ddF_y = -2 * R
			local x = 0
			local y = R
		 
			Map_Block_Change(Client_ID, Map_ID, X1, Y1 + R, Z1, 1, Mat2, 4, 1, 0)
			Map_Block_Change(Client_ID, Map_ID, X1, Y1 - R, Z1, 1, Mat2, 4, 1, 0)
			Map_Block_Change(Client_ID, Map_ID, X1 + R, Y1, Z1, 1, Mat2, 4, 1, 0)
			Map_Block_Change(Client_ID, Map_ID, X1 - R, Y1, Z1, 1, Mat2, 4, 1, 0)
		 
			while x < y do
				if f >= 0 then
					y = y-1
					ddF_y = ddF_y + 2
					f = f+ddF_y
				end
				x = x+1
				ddF_x = ddF_x+2
				f = f+ddF_x		
				Map_Block_Change(Client_ID, Map_ID, X1 + x, Y1 + y, Z1, 1, Mat2, 4, 1, 0)
				Map_Block_Change(Client_ID, Map_ID, X1 - x, Y1 + y, Z1, 1, Mat2, 4, 1, 0)
				Map_Block_Change(Client_ID, Map_ID, X1 + x, Y1 - y, Z1, 1, Mat2, 4, 1, 0)
				Map_Block_Change(Client_ID, Map_ID, X1 - x, Y1 - y, Z1, 1, Mat2, 4, 1, 0)
				Map_Block_Change(Client_ID, Map_ID, X1 + y, Y1 + x, Z1, 1, Mat2, 4, 1, 0)
				Map_Block_Change(Client_ID, Map_ID, X1 - y, Y1 + x, Z1, 1, Mat2, 4, 1, 0)
				Map_Block_Change(Client_ID, Map_ID, X1 + y, Y1 - x, Z1, 1, Mat2, 4, 1, 0)
				Map_Block_Change(Client_ID, Map_ID, X1 - y, Y1 - x, Z1, 1, Mat2, 4, 1, 0)
			end
			
		end
	},
	{
		name="centre",
		blocks=2,
		rank=100,
		rankshow=100,
		desc="finds centre between 2 placed points",
		create=function(Client_ID, ...) end, --can be used for info, etc..
		finish=function(Client_ID, ...)
			local Map_ID,Mat1,X1,Y1,Z1 = unpack(arg[1])
			local Map_ID2,Mat2,X2,Y2,Z2 = unpack(arg[2])
			if Map_ID ~= Map_ID2 then return end
			
			local CX, CY, CZ = (X1+X2)/2,(Y1+Y2)/2,(Z1+Z2)/2
			for xi=0,1 do
				local x = -1
				if xi == 0 then
					x = math.floor(CX)
				else
					x = math.ceil(CX)
				end
				for yi=0,1 do
					local y = -1
					if yi == 0 then
						y = math.floor(CY)
					else
						y = math.ceil(CY)
					end
					for zi=0,1 do
						local z = -1
						if zi == 0 then
							z = math.floor(CZ)
						else
							z = math.ceil(CZ)
						end
						Map_Block_Change(Client_ID, Map_ID, x, y, z, 1, Mat2, 4, 1, 0)
					end
				end
			end
			System_Message_Network_Send(Client_ID, "&ecentre: "..CX..", "..CY..", "..CZ)
		end
	},
	{
		name="measure",
		blocks=2,
		rank=100,
		rankshow=100,
		desc="measure between 2 points..",
		create=function(Client_ID, ...) end, --can be used for info, etc..
		finish=function(Client_ID, ...)
			local Map_ID,Mat1,X1,Y1,Z1 = unpack(arg[1])
			local Map_ID2,Mat2,X2,Y2,Z2 = unpack(arg[2])
			if Map_ID ~= Map_ID2 then return end
			local pyth = getDistance3D(X1,Y1,Z1,X2,Y2,Z2)
			System_Message_Network_Send(Client_ID, "&eDistance(pyth): "..pyth.."m")
			local D_X = X1 - X2
			local D_Y = Y1 - Y2
			local D_Z = Z1 - Z2
			local Blocks = 1
			if Blocks < math.abs(D_X) then Blocks = math.abs(D_X) end
			if Blocks < math.abs(D_Y) then Blocks = math.abs(D_Y) end
			if Blocks < math.abs(D_Z) then Blocks = math.abs(D_Z) end
			System_Message_Network_Send(Client_ID, "&eBlocks(D3 line algorithym): "..Blocks)
		end
	},
	{
		name="yang",
		blocks=2,
		rank=100,
		rankshow=100,
		desc="Makes the ying yang symbol",
		create=function(Client_ID, ...) end, --can be used for info, etc..
		finish=function(Client_ID, ...)
			local Map_ID,Mat1,X1,Y1,Z1 = unpack(arg[1])
			local Map_ID2,Mat2,X2,Y2,Z2 = unpack(arg[2])
			if Map_ID ~= Map_ID2 then return end
			local R = math.floor(getDistance3D(X1,Y1,0,X2,Y2,0))
			for ix=-R,R do
				local mat = 49
				if ix>0 then
					mat = 36
				end
				for iy=-R,R do
					if math.pow(ix,2)+math.pow(iy,2) <= R^2 then
						Map_Block_Change(Client_ID, Map_ID, X1+ix, Y1+iy, Z1, 1, mat, 4, 1, 0)
					end
				end
			end

			local X,Y,Z = X1,math.floor(R/2+Y1),Z1
			local nR = math.floor(R/2)
			for ix=-nR,nR do
				for iy=-nR,nR do
					if math.pow(ix,2)+math.pow(iy,2) <= nR^2 then
						Map_Block_Change(Client_ID, Map_ID, X+ix, Y+iy, Z+1, 1, 49, 4, 1, 0)
					end
				end
			end
			local nR = math.floor(nR/3)
			for ix=-nR,nR do
				for iy=-nR,nR do
					if math.pow(ix,2)+math.pow(iy,2) <= nR^2 then
						Map_Block_Change(Client_ID, Map_ID, X+ix, Y+iy, Z+2, 1, 36, 4, 1, 0)
					end
				end
			end
			
			local X,Y,Z = X1,math.floor(Y1-(R/2)),Z1
			local nR = math.floor(R/2)
			for ix=-nR,nR do
				for iy=-nR,nR do
					if math.pow(ix,2)+math.pow(iy,2) <= nR^2 then
						Map_Block_Change(Client_ID, Map_ID, X+ix, Y+iy, Z+1, 1, 36, 4, 1, 0)
					end
				end
			end
			local nR = math.floor(nR/3)
			for ix=-nR,nR do
				for iy=-nR,nR do
					if math.pow(ix,2)+math.pow(iy,2) <= nR^2 then
						Map_Block_Change(Client_ID, Map_ID, X+ix, Y+iy, Z+2, 1, 49, 4, 1, 0)
					end
				end
			end
		end
	},
	{
		name="paint",
		blocks=0,
		rank=100,
		rankshow=100,
		desc="Draw things by deleting blocks..",
		delete=function(Map_ID,Client_ID,Material,X,Y,Z)
			Map_Block_Change(Client_ID, Map_ID, X, Y, Z, 1, Material, 4, 1, 1)
			return 0
		end
	},
	{
		name="noact",
		blocks=0,
		rank=100,
		--rankshow=100,
		desc="Change blocks without activating physics",
		create=function(Map_ID,Client_ID,Material,X,Y,Z)
			local Player_Number = Client_Get_Player_Number(Client_ID)
			Map_Block_Change_Fast(Player_Number, Map_ID, X, Y, Z, Material, 0, 1, 0, 1)
			--Map_Block_Change(Client_ID, Map_ID, X, Y, Z+1, 1, Material, 4, 1, 0)
			return 0
		end,
		delete=function(Map_ID,Client_ID,Material,X,Y,Z)
			local Player_Number = Client_Get_Player_Number(Client_ID)
			Map_Block_Change_Fast(Player_Number, Map_ID, X, Y, Z, 0, 0, 1, 0, 1)
			--Map_Block_Change(Client_ID, Map_ID, X, Y, Z, 1, 0, 4, 1, 0)
			return 0
		end
	},
	{
		name="fake",
		blocks=0,
		rank=255,
		--rankshow=100,
		desc="Change blocks without activating physics",
		create=function(Map_ID,Client_ID,Material,X,Y,Z)
			--local Player_Number = Client_Get_Player_Number(Client_ID)
			Map_Block_Fake(Map_ID, X, Y, Z, Material)
			--Map_Block_Change_Fast(Player_Number, Map_ID, X, Y, Z, Material, 0, 1, 0, 1)
			--Map_Block_Change(Client_ID, Map_ID, X, Y, Z+1, 1, Material, 4, 1, 0)
			return 0
		end,
		delete=function(Map_ID,Client_ID,Material,X,Y,Z)
			--local Player_Number = Client_Get_Player_Number(Client_ID)
			Map_Block_Fake(Map_ID, X, Y, Z, 0)
			--Map_Block_Change_Fast(Player_Number, Map_ID, X, Y, Z, 0, 0, 1, 0, 1)
			--Map_Block_Change(Client_ID, Map_ID, X, Y, Z, 1, 0, 4, 1, 0)
			return 0
		end
	},
	{
		name="bget",
		blocks=0,
		rank=100,
		--rankshow=100,
		desc="",
		create=function(Map_ID,Client_ID,Material,X,Y,Z)
			local client = client.new(Client_ID)
			client:message(Map_Block_Get_Type(Map_ID, X, Y, Z))
			return 0
		end,
		delete=function(Map_ID,Client_ID,Material,X,Y,Z)
			local client = client.new(Client_ID)
			client:message(Map_Block_Get_Type(Map_ID, X, Y, Z))
			return 0
		end
	},
	{
		name="land",
		blocks=2,
		rank=1337,
		desk="",
		finish=RPG_addLand 
	}
}
function BuildMode_Cancel(Client_ID,Reason) --overwrite old cancel function, add cancel function support.
	local funcd = -1
	if Build_Funcs[BuildMode[Client_ID] ] then
		funcd = Build_Funcs[BuildMode[Client_ID] ] --get old buildmode.. before its changed
	end
	
	BuildMode[Client_ID] = {
		mode=0,
		blocks={}
	}
	if Reason then
		System_Message_Network_Send(Client_ID, "&eBuild mode cancelled. ("..Reason..")")
	end
	
	if funcd ~= -1 and funcd.cancel then
		funcd.cancel(Client_ID)
	end
end
function BuildMode_Set(Client_ID,Mode)
	--[[local funcd = -1
	if Build_Funcs[BuildMode[Client_ID] ] then
		funcd = Build_Funcs[BuildMode[Client_ID] ] --get old buildmode..
	end]]
	BuildMode_Cancel(Client_ID)
	BuildMode[Client_ID].mode = Mode
	
	--[[if funcd ~= -1 and funcd.cancel then --after switching mode. (after switching mode incase causes crash)
		funcd.cancel(Client_ID)
	end]]
	
	local funcd = Build_Funcs[Mode] --new bmode.. much easier to get than old one :)
	if funcd.start then
		funcd.start(Client_ID)
	end
end

--the function for storing block changes, etc
function BuildMode_Block(Map_ID, Client_ID, Mode, ...) --... = Material, X, Y, Z
	local Material, X, Y, Z = ...
	if Client_ID == 0 then return 1 end
	local binf = BuildMode[Client_ID]
	if binf.mode == 0 then return 1 end --no build mode.. let them build normally..
	local funcd = Build_Funcs[binf.mode]
	if Mode == 0 then
		if funcd.delete then
			return funcd.delete(Map_ID,Client_ID,...)
		else
			return 0
		end
	else
		if funcd.finish and funcd.blocks>0 then
			table.insert(BuildMode[Client_ID]["blocks"],{Map_ID,...})
			local binf = BuildMode[Client_ID]

			if #binf.blocks >= funcd.blocks then
				BuildMode_Cancel(Client_ID)
				funcd.finish(Client_ID,unpack(binf.blocks))
			end
		end
		if funcd.create then
			return funcd.create(Map_ID,Client_ID,...)
		else
			--return 0 --fucking line!
		end
		return 1
	end
	print("unhandled...")
	--return 0
end

function Command_BuildMode(Client_ID, Command, Text_0, Text_1, Arg_0, Arg_1, Arg_2, Arg_3, Arg_4)
	local client = client.new(Client_ID)
	local rank = client:rank()
	if Arg_0 == "" or Arg_0 == "list" then --list build modes..
		if BuildMode[Client_ID].mode ~= 0 and Arg_0 ~= "list" then
			System_Message_Network_Send(Client_ID, "&eBuild Mode Cancelled.")
			BuildMode_Cancel(Client_ID)
		else
			System_Message_Network_Send(Client_ID, "&eBuild Modes:-")
			for i,v in pairs(Build_Funcs) do
				print(v.rank,v.showrank)
				if (v.rank ~= nil and v.rank <= rank) and (v.rankshow ~= nil and v.rankshow <= rank) then
					local desc = ""
					if v.desc ~= nil then desc = v.desc end
					System_Message_Network_Send(Client_ID, "&e"..v.name.." - "..desc)
				end
			end
		end
	else
		if Arg_0 == "cancel" then
			System_Message_Network_Send(Client_ID, "&eBuild Mode Cancelled.")
			BuildMode_Cancel(Client_ID)
			return
		end
		local mode = -1
		for i,v in ipairs(Build_Funcs) do
			if v.name == Arg_0:lower() then
				mode = i
			end
		end
		if mode == -1 then
			System_Message_Network_Send(Client_ID, "&eNo such build mode exists.")
		else
			--[[BuildMode_Cancel(Client_ID)
			BuildMode[Client_ID].mode = mode]]
			BuildMode_Set(Client_ID,mode)
			System_Message_Network_Send(Client_ID, "&eBuildmode set to '"..Arg_0.."'")
		end
	end
end
System_Message_Network_Send_2_All(-1, "&0bm dbg")
